<?php
require_once(dirname(__FILE__).'/functions_requestRemote.php');
define('CACHE_PATH',dirname(dirname(__FILE__)) . '/vb/cache/');
//admin functions start
function checkSlash($path){
    $path = trim($path);
    if(substr($path,-1,1) != "/" && !empty($path)){
        $path = $path."/";
    }
    return $path;
}

function validate_data_api($data_api){
    $da = 1;
    if(substr(topcmmRequestRemote::requestRemote($data_api,0), 9, 3) == 200){
        $da = 0;
    }
    return $da;
}

function validate_client($client_loc){
    $c_own_loc = 1;
    $swf = $client_loc . 'admin_123flashchat.swf';
    if($headers = topcmmRequestRemote::requestRemote($swf,0)){
        $c_own_loc = (substr($headers, 9, 3) == '200') ? 0 : 1;
    }
    return $c_own_loc;
}

function getValid($chatSetting){
	$c_server_loc = 1;
	if($chatSetting['fc_server_host']){
		if($chatSetting['fc_server_host'] == $_SERVER['SERVER_NAME']){
			$c_own_loc = validate_client('http://'.$chatSetting['fc_server_host'].':'.$chatSetting['fc_server_port_h'].'/');
			if(!$c_own_loc){
				$c_server_loc = 0;
			}
		}
	}else{
		$c_own_loc = validate_client('http://'.$_SERVER['SERVER_NAME'].':'.$chatSetting['fc_server_port_h'].'/');
		if(!$c_own_loc){
			$c_server_loc = 0;
		}
	}
	return $c_server_loc;
}

function getServerHostPortLocal($client_location){
	$content = topcmmRequestRemote::requestRemote($client_location.'htmlchat/config/config.js',1);
	if ($content){
		//server host
		preg_match('/init_host = "([a-zA-Z0-9.]*)";/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host'] = $matches[1];
		}else{
			preg_match('/init_host="([a-zA-Z0-9.]*)";/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host'] = $matches[1];
			}else{
				$data['fc_server_host'] = '';
			}
		}
		//server port
		preg_match('/init_port = ([0-9]*);/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port'] = $matches[1];
		}else{
			$data['fc_server_port'] = '';
		}
		//server host s
		preg_match('/init_host_s = "([a-zA-Z0-9.]*)";/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host_s'] = $matches[1];
		}else{
			preg_match('/init_host_s="([a-zA-Z0-9.]*)";/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host_s'] = $matches[1];
			}else{
				$data['fc_server_host_s'] = '';
			}
		}
		//server port s
		preg_match('/init_port_s = ([0-9]*);/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port_s'] = $matches[1];
		}else{
			$data['fc_server_port_s'] = '';
		}
		//server host h
		preg_match('/init_host_h = "([a-zA-Z0-9.]*)";/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host_h'] = $matches[1];
		}else{
			preg_match('/init_host_h="([a-zA-Z0-9.]*)";/', $content, $matches);
			if(isset($matches[1])){
				$data['fc_server_host_h'] = $matches[1];
			}else{
				$data['fc_server_host_h'] = '';
			}
		}
		//server port h
		preg_match('/init_port_h = ([0-9]*);/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port_h'] = $matches[1];
		}else{
			$data['fc_server_port_h'] = '';
		}
		return $data;
	}else{
		return false;
	}
}

function getServerHostPortHost($client_location){
	$content = topcmmRequestRemote::requestRemote($client_location,1);
	if ($content){
		//server port
		preg_match('/init_port=([0-9]*)/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port'] = $matches[1];
		}
		//server port s
		preg_match('/init_port_s=([0-9]*)/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port_s'] = $matches[1];
		}
		//server port h
		preg_match('/init_port_h=([0-9]*)/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_port_h'] = $matches[1];
		}
		//server host
		preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host'] = $matches[1];
		}
		//server host s
		preg_match('/init_host_s=([a-zA-Z0-9.]*)&/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host_s'] = $matches[1];
		}
		//server host h
		preg_match('/init_host_h=([a-zA-Z0-9.]*)&/', $content, $matches);
		if(isset($matches[1])){
			$data['fc_server_host_h'] = $matches[1];
		}
		return $data;
	}else{
		return false;
	}
}
//admin functions ends

//public functions start
function fc_get_chat_url(){
    global $settingscache, $grouptitlecache, $vbulletin, $vbphrase, $bgcounter, $settingphrase;
    $url = '';
	$extendserver = $vbulletin->options['fc_extendserver'];
	$servertype = $vbulletin->options['fc_servertype'];
	$clienttype = $vbulletin->options['fc_clienttype'];
	$client_loc = $vbulletin->options['fc_client_loc'];
	$server_host_s = $vbulletin->options['fc_server_host_s'];
	$server_port_s = $vbulletin->options['fc_server_port_s'];
	$server_host_h = $vbulletin->options['fc_server_host_h'];
	$server_port_h = $vbulletin->options['fc_server_port_h'];
    switch($extendserver){
		case 0:
			if($servertype != 1 && $clienttype == 1){                
				$clientname = '123flashchat.swf';
			}else{
				$clientname = 'htmlchat/123flashchat.html';
			}
			$url .= $client_loc . $clientname . "?init_host=" . $vbulletin->options['fc_server_host'] . "&init_port=" . $vbulletin->options['fc_server_port'] ;
            $url .= ($server_host_s ? "&init_host_s=".$server_host_s : "") . ($server_port_s ? "&init_port_s=".$server_port_s : "");
			$url .= ($server_host_h ? "&init_host_h=".$server_host_h : "") . ($server_port_h ? "&init_port_h=".$server_port_h : "");			
		break;
		case 1:
			if($clienttype == 1){
				$clientname = '123flashchat.swf';
			}else{
				$clientname = 'htmlchat/123flashchat.html';
			}
			$url = $client_loc . $clientname . "?init_host=" . $vbulletin->options['fc_server_host'] . "&init_port=" . $vbulletin->options['fc_server_port'];
            $url .= ($server_host_s ? "&init_host_s=".$server_host_s : "") . ($server_port_s ? "&init_port_s=".$server_port_s : "");
			$url .= ($server_host_h ? "&init_host_h=".$server_host_h : "") . ($server_port_h ? "&init_port_h=".$server_port_h : "");
			$url .= "&init_group=" . $vbulletin->options['fc_group'];
		break;
		case 2:
			$url .= "http://free.123flashchat.com/js.php?room=" . urlencode($vbulletin->options['fc_room']) . "&skin="  . $vbulletin->options['fc_client_skin'] . "&lang="  . $vbulletin->options['fc_client_lang'];
		break;
	}
	if($_GET['room']){
		$url .= "&init_room=".$_GET['room'];
	}
    return $url;
}

function fc_get_status(){
    global $settingscache, $grouptitlecache, $vbulletin, $vbphrase, $bgcounter, $settingphrase;
    $data = topcmmRequestRemote::requestRemote(CACHE_PATH . "status.js",1);
    $status_json = substr($data,10);
    if ((time() > substr($data,0,10)) || !$status_json){
        $server =  $vbulletin->options['fc_extendserver'];
        switch ($server){
            case "0":
                $status_js = $vbulletin->options['fc_api_url'] . "online.js";
                if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                    $status_json = substr($rs,11,-1);
                }
                break;
            case "1":
                $status_js = $vbulletin->options['fc_api_url'] . "online.js?group=" .$vbulletin->options['fc_group'];
                if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                    $status_json = substr($rs,11,-1);
                }
                break;
            case "2":
                $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $vbulletin->options['fc_room'];
                if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                    preg_match("/document.write\('(.*)'\);/",$rs,$matches);
                    $status['ln'] = $matches[1];
                    $status_json = json_encode($status);
                }
                break;
        }
        @file_put_contents(CACHE_PATH . "status.js",(time() + 120) . $status_json);
    }
    return json_decode($status_json,true);
}

function fc_get_room_list(){
    global $settingscache, $grouptitlecache, $vbulletin, $vbphrase, $bgcounter, $settingphrase;
	$data = topcmmRequestRemote::requestRemote(CACHE_PATH ."rooms.js", 1);
    $rooms_json = substr($data,10);
    if ((time() > substr($data,0,10)) || !$rooms_json){
        $server = $vbulletin->options['fc_extendserver'];
		switch ($server){
            case "0":
                $room_js = $vbulletin->options['fc_api_url'] . "rooms.js";
                break;
            case "1":
                $room_js = $vbulletin->options['fc_api_url'] . "rooms.js?group=" . $vbulletin->options['fc_group'];
                break;
        }
        if($rs = topcmmRequestRemote::requestRemote($room_js,1)){
            $rooms_json = substr($rs,10,-1);
        }
        @file_put_contents(CACHE_PATH ."rooms.js",(time() + 120) . $rooms_json);
    }
    return json_decode($rooms_json, true);
}

function fc_get_user_list(){
    global $settingscache, $grouptitlecache, $vbulletin, $vbphrase, $bgcounter, $settingphrase;
	$opts = array('http'=>array('timeout'=>3,));
	$context = stream_context_create($opts);
	$data =  topcmmRequestRemote::requestRemote(CACHE_PATH."users.js",1);
	$users_json = substr($data,10);
    if ((time() > substr($data,0,10)) || !$users_json){
    	$server =  $vbulletin->options['fc_extendserver'];
        switch ($server){
            case 0:
                $rooms = fc_get_room_list();
                if ($rooms == null){
                	return null;
                }
                $users = array();
                foreach ($rooms as $room){
                    $user_js = $vbulletin->options['fc_api_url'] . "roomonlineusers.js?roomid=" . $room['id'];
                    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
                    }
                }
                $users_json = json_encode($users);
        	    break;
            case 1:
        	    $user_js = $vbulletin->options['fc_api_url'] . "roomonlineusers.js?group=" . $vbulletin->options['fc_group'];
        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
        	        $users_json = substr($rs,20,-1);
        	    }
        	    break;
        	case 2:
        		$users = array();       		
        	    $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $vbulletin->options['fc_room'];
        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
    	            foreach (explode(',', $matches[1]) as $user){
    	                $users[] = array('name' => $user);
    	            }
    	        }
    	        $users_json = json_encode($users);
    	        break;
        }
        $users_json = filterUserList($users_json);
        @file_put_contents(CACHE_PATH."users.js",(time() + 120) . $users_json);
    }
    return json_decode($users_json, true);
}

function filterUserList($users_json){
	$user_array =  json_decode($users_json,true);
	$user_regroup_array = array();
	$user_tmp_array = array();
	if($user_array){
		foreach($user_array as $key => $val){
			if (!in_array($val['name'], $user_tmp_array)){
				$user_tmp_array[] = $val['name'];
				$user_regroup_array[$key] = $user_array[$key];
			}
		}
	}
	return json_encode($user_regroup_array);
}

//public functions ends