<?php

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array();
$specialtemplates = array();

// ########################## REQUIRE BACK-END ############################
chdir(dirname(__FILE__) . "/../../../admincp");
require_once('./global.php');
require_once(dirname(dirname(__FILE__)).'/includes/functions_123flashchat.php');
// ############################# LOG ACTION ###############################
log_admin_action();

define('BATCH_NUMBERS',100);

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################
ini_set("default_socket_timeout",10);
print_cp_header($vbphrase['123flashchat']);

if (empty($_REQUEST['do'])){
    $_REQUEST['do'] = 'config';
}

if ($_REQUEST['do'] == "doconfig"){
    $vbulletin->input->clean_array_gpc('p', array(    
    		'fc_extendserver' => TYPE_INT,
    		'fc_servertype'	 => TYPE_INT,
			'fc_server_host' => TYPE_STR,
            'fc_server_port' => TYPE_INT,
            'fc_server_host_s' => TYPE_STR,
            'fc_server_port_s' => TYPE_INT,
    		'fc_server_host_h' => TYPE_STR,
            'fc_server_port_h' => TYPE_INT,
            'fc_client_loc'  => TYPE_STR,
			'fc_api_url' => TYPE_STR,
			'fc_group' => TYPE_STR,
            'fc_room'   => TYPE_STR,
			'fc_fullscreen' => TYPE_INT,
            'fc_room_list' => TYPE_INT,
            'fc_user_list' => TYPE_INT,	
    		'fc_clienttype'  => TYPE_INT,	
			'fc_client_width' => TYPE_INT,
			'fc_client_height' => TYPE_INT,
			'fc_client_lang' => TYPE_STR,
			'fc_client_skin' => TYPE_STR,
    ));
	$fcsetting['fc_extendserver'] = $vbulletin->GPC['fc_extendserver'];
	switch ($fcsetting['fc_extendserver']){
        case 0:
        	$fcsetting['fc_servertype'] = $vbulletin->GPC['fc_servertype'];
			$client_location = $vbulletin->GPC['fc_client_loc'];
			if($client_location){
				$fcsetting['fc_client_loc'] = $client_location . (substr($client_location,-1,1) != '/' ? '/' : '');
				
				$serverinfo = getServerHostPortLocal($fcsetting['fc_client_loc']);
	            $fcsetting['fc_server_host'] = !empty($vbulletin->GPC['fc_server_host']) ? $vbulletin->GPC['fc_server_host'] : (empty($serverinfo['fc_server_host']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host']) ;
	            $fcsetting['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? $fcsetting['fc_server_host'] : $serverinfo['fc_server_host_s'];
	            $fcsetting['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? $fcsetting['fc_server_host'] : $serverinfo['fc_server_host_h'];
	            if(!is_numeric($vbulletin->GPC['fc_server_port']) || strpos($vbulletin->GPC['fc_server_port'] ,".")!==false){
	            	$fcsetting['fc_server_port'] = empty($serverinfo['fc_server_port']) ? ($fcsetting['fc_servertype'] ==1 ? '51212' : '51127') : $serverinfo['fc_server_port'] ;
	            }else{
	            	$fcsetting['fc_server_port'] = $vbulletin->GPC['fc_server_port'];
	            }
	            if(!is_numeric($vbulletin->GPC['fc_server_port_h']) || strpos($vbulletin->GPC['fc_server_port_h'] ,".")!==false){
	            	$fcsetting['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? ($fcsetting['fc_servertype'] ==1 ? '31212' : '35555') : $serverinfo['fc_server_port_h'] ;
	            }else{
	            	$fcsetting['fc_server_port_h'] = $vbulletin->GPC['fc_server_port_h'];
	            }
	            $fcsetting['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? ($fcsetting['fc_servertype'] ==1 ? '51213' : '51128') : $serverinfo['fc_server_port_s'] ;
	            $fcsetting['fc_api_url'] = 'http://' . $fcsetting['fc_server_host'] . ':' . $fcsetting['fc_server_port_h'] . '/';
			}else{
				$fcsetting['fc_server_host'] = $_SERVER['HTTP_HOST'];
	            $fcsetting['fc_server_host_h'] = $fcsetting['fc_server_host_s'] = $fcsetting['fc_server_host'];
				if($fcsetting['fc_servertype']){
					$fcsetting['fc_server_port_h'] = '31212';
		            $fcsetting['fc_server_port_s'] = '51213';
					$fcsetting['fc_server_port'] = '51212';
				}else{
					$fcsetting['fc_server_port_h'] = '35555';
		            $fcsetting['fc_server_port_s'] = '51128';
					$fcsetting['fc_server_port'] = '51127';
				}
	            $fcsetting['fc_api_url'] = 'http://' . $fcsetting['fc_server_host'] . ':' . $fcsetting['fc_server_port_h'] . '/';
	            $fcsetting['fc_client_loc'] = $fcsetting['fc_api_url'];            
			}
			if($fcsetting['fc_servertype'] == 1){
		        $fcsetting['fc_clienttype'] = 0;
		    }else{
		        $fcsetting['fc_clienttype'] = $vbulletin->GPC['fc_clienttype'];
		    }
			$s_own_loc = 1;
			$c_own_loc = 1;
			$da = 1;
			if($vbulletin->GPC['server_loc']){
				$c_own_loc = validate_client($fcsetting['fc_client_loc']);
				$da = validate_data_api($fcsetting['fc_api_url'] . 'online.js');
				if($c_own_loc || $da){
					$error[] = 'Chat Server host or port is configured incorrectly';
				}
			}else{
				$c_own_loc = validate_client($fcsetting['fc_client_loc']);
				if($c_own_loc){
					$error[] = 'Chat Server http_port or Client location is configured incorrectly';
				}
			}
			$check = validate_client('http://'.parse_url($fcsetting['fc_client_loc'], PHP_URL_HOST).':'.$fcsetting['fc_server_port_h'].'/');
			if($check){
				$error[] = 'Client Location is configured incorrectly';
			}        	 
            break;
        case 1:
			$fcsetting['fc_client_loc'] = $vbulletin->GPC['fc_client_loc'] ? ($vbulletin->GPC['fc_client_loc'] . (substr($vbulletin->GPC['fc_client_loc'],-1,1) != '/' ? '/' : '')) : '';
			if(empty($fcsetting['fc_client_loc'])){
				$error[] = 'Client Location is Empty!';
			}
			$serverinfo = getServerHostPortHost($fcsetting['fc_client_loc']);
			if($serverinfo){					
				$fcsetting['fc_server_host'] = empty($serverinfo['fc_server_host']) ? parse_url($fcsetting['fc_client_loc'], PHP_URL_HOST) : $serverinfo['fc_server_host'];
				$fcsetting['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? '' : $serverinfo['fc_server_host_s'];
				$fcsetting['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? '' : $serverinfo['fc_server_host_h'];
				$fcsetting['fc_server_port'] = empty($serverinfo['fc_server_port']) ? '' : $serverinfo['fc_server_port'];
				$fcsetting['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? '' : $serverinfo['fc_server_port_h'];
	            $fcsetting['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? '' : $serverinfo['fc_server_port_s'];
	            $fcsetting['fc_api_url'] = 'http://' . $fcsetting['fc_server_host'] . '/';
	            $fcsetting['fc_group'] = substr(parse_url($fcsetting['fc_client_loc'], PHP_URL_PATH),1,-1);
				$c_own_loc = validate_client($fcsetting['fc_client_loc']);
				$da = validate_data_api($fcsetting['fc_api_url'] . 'online.js?group=' . $fcsetting['fc_group']);
		        if($c_own_loc || $da){
		        	$error[] = 'Client Location is configured incorrectly';
		        }
			}else{
				$error[] = 'Client Location is configured incorrectly';
			}        	
            break;
        case 2:
        	$room = trim($vbulletin->GPC['fc_room']);
			if($room != ""){
				preg_match("/\w+$/", $room,$matches);
				if(strlen($room) != strlen($matches[0])){
					$error[] = "Chat Room can only use numbers,letters and underline!";
				}
				$fcsetting['fc_room'] = $room;
			}else{
				$fcsetting['fc_room'] = 'Lobby';
			}         
            break;
    }
    $fcsetting['fc_clienttype'] = $vbulletin->GPC['fc_clienttype'];
    $fcsetting['fc_fullscreen'] = $vbulletin->GPC['fc_fullscreen'];
    $fcsetting['fc_client_width'] = ($vbulletin->GPC['fc_client_width'] > 760 ) ? $vbulletin->GPC['fc_client_width'] : 760;
    $fcsetting['fc_client_height'] = ($vbulletin->GPC['fc_client_height'] > 642) ? $vbulletin->GPC['fc_client_height'] : 642;

    $fcsetting['fc_room_list'] = $vbulletin->GPC['fc_room_list'];
    $fcsetting['fc_user_list'] = $vbulletin->GPC['fc_user_list'];
	
    $fcsetting['fc_client_lang'] = $vbulletin->GPC['fc_client_lang'];
	$fcsetting['fc_client_skin'] = $vbulletin->GPC['fc_client_skin'];	
    
	if (!sizeof($error)){
        foreach ($fcsetting as $varname => $value){
            $vbulletin->db->query_write("
				UPDATE " . TABLE_PREFIX . "setting
				SET value = '" . $vbulletin->db->escape_string($value) . "'
				WHERE varname = '" . $vbulletin->db->escape_string($varname) . "'
			");
        }
        build_options();
        define('CP_REDIRECT', 'admin_123flashchat.php');
        print_stop_message('saved_settings_successfully');
    }else{
        $error_msg=implode('<br />',$error);
        $_REQUEST['do'] = "config";
    }
}
if ($_REQUEST['do'] == "config"){
    if (!isset($fcsetting)){
        $fcsetting['fc_extendserver'] = $vbulletin->options['fc_extendserver'];
        $fcsetting['fc_servertype'] = $vbulletin->options['fc_servertype'];
        $fcsetting['fc_server_host'] = $vbulletin->options['fc_server_host'];
        $fcsetting['fc_server_port'] = $vbulletin->options['fc_server_port'];
        $fcsetting['fc_server_port_h'] = $vbulletin->options['fc_server_port_h'];
        $fcsetting['fc_client_loc'] = $vbulletin->options['fc_client_loc'];
        $fcsetting['fc_clienttype'] = $vbulletin->options['fc_clienttype'];        
        $fcsetting['fc_room'] = $vbulletin->options['fc_room'];
        $fcsetting['fc_room_list'] = $vbulletin->options['fc_room_list'];
        $fcsetting['fc_user_list'] = $vbulletin->options['fc_user_list'];
		$fcsetting['fc_fullscreen'] =$vbulletin->options['fc_fullscreen'];
        $fcsetting['fc_client_width'] =$vbulletin->options['fc_client_width'];
        $fcsetting['fc_client_height'] =$vbulletin->options['fc_client_height'];
		$fcsetting['fc_client_lang'] =$vbulletin->options['fc_client_lang'];
		$fcsetting['fc_client_skin'] =$vbulletin->options['fc_client_skin'];
    }
    $valid = getValid( $fcsetting);
?>
<div class="pagetitle">123 Flash Chat Settings</div>
<script type="text/javascript" src="<?php echo $vbulletin->options['bburl']; ?>/packages/123flashchat/admincp/123flashchat_setting.js"></script>
<style>
	tr th{text-align:right;}
	#chatsize{ padding-left:20px;}
</style>
<div class="acp-content-wrapper">
<?php

    //* Command list *
    // Redlieving of the commands
    print_form_header('admin_123flashchat', 'doconfig');
    print_table_header($vbphrase['chat_settings'], 2, 0);
    if(!empty($error_msg)){
?>
	<tr>
		<th class="alt1" colspan="2"><p style="color:red;text-align:center;"><?php echo $error_msg; ?></p></th>
	</tr>
<?php 
    }
?>
	<tr valign="top">
		<th class="alt2" rowspan="3" style="width: 200px;" ><span title="3 options for you to choose.">Server Mode</span></th>
		<td class="alt2">
			<input type="radio" name="fc_extendserver" id="extendserver0" value="0" onclick="changeserver('0')" <?php if($fcsetting['fc_extendserver'] == 0){ ?>checked="checked"<?php } ?>>
			<label for="extendserver0">123FlashChat Server Hosted By Own</label>
			<br /><p class="note">Please download and install 123FlashChat first: <a target="_blank" href="http://www.123flashchat.com/download.html"> http://www.123flashchat.com/download.html</a></p>
		</td>
	</tr>
	<tr valign="top">
		<td class="alt2">
			<input type="radio" name="fc_extendserver" id="extendserver1" value="1" onclick="changeserver('1')" <?php if($fcsetting['fc_extendserver'] == 1){ ?>checked="checked"<?php } ?>>
			<label for="extendserver1">123FlashChat Server Hosted By 123 Flash Chat</label>
			<br /><p class="note"><a target="_blank" href="http://www.123flashchat.com/host.html">For paid host</a>, please set the Chat Client Location like this, for example: http://host71200.123flashchat.com/wordpress/, <a target="_blank" href="http://www.123flashchat.com/host.html">Buy host</a><br>
			<a target="_blank" href="http://www.123flashchat.com/host/apply.php">For trial host</a>, please setup Chat Client Location like this: http://trial.123flashchat.com/yourhostname<br>
			Just replace "yourhostname" to the real one when you applied, <a target="_blank" href="http://www.123flashchat.com/host/apply.php">Apply trial host</a></p>
		</td>
	</tr>
	<tr valign="top">
		<td class="alt2"><input type="radio" name="fc_extendserver" id="extendserver2" value="2" onclick="changeserver('2')" <?php if($fcsetting['fc_extendserver'] == 2){ ?>checked="checked"<?php } ?>>
		<label for="extendserver2">Chat Server Host By 123 Flash Chat For Free</label>
			<br /><p class="note">This chat server mode aims at testing the basic functions, only supported 1 room, no video chat function, and also you don't have the administrator permission of entering this chat room, you can select the mode 1 or 2 to get the full functions and control your chat room.</p>
		</td>
	</tr>	
	<tr valign="top" id="login_chat" <?php if($fcsetting['fc_extendserver'] == 2){ ?>style="display:none;"<?php } ?>>
		<th class="alt1">Integration URL</th>
		<td class="alt1">To integrate users for auto-login to chat, please open the Chat Admin Panel, then System Settings &gt; Integration Panel, set authentication URL to:<br />
			<span style="color:red;"><?php echo $vbulletin->options['bburl']; ?>/packages/123flashchat/login_chat.php?username=%username%&password=%password%</span><br />
			Then restart your chat server : Server Management &gt; Restart &gt; click Restart Server</td>
	</tr>
	<tr class="alternate" id="servertype" <?php if($fcsetting['fc_extendserver'] != 0){?>style="display:none;"<?php } ?>>
        <th class="alt2">Server Type</th>
        <td class="alt2">
            <input type="radio" name="fc_servertype" value="0" <?php if($fcsetting['fc_servertype'] == 0){?>checked="checked"<?php } ?> id="servertype0" onclick="chooseservertype('0')" /><label for="servertype0">123FlashChat</label>
            <input type="radio" name="fc_servertype" value="1" <?php if($fcsetting['fc_servertype'] == 1){?>checked="checked"<?php } ?> id="servertype1" onclick="chooseservertype('1')" /><label for="servertype1">123PPVSoftware</label>                            
        </td>
    </tr>
	<tr valign="top" id='chat_host' <?php if(!$valid || $fcsetting['fc_extendserver'] != 0){ ?>style="display:none;"<?php } ?> >
		<th class="alt1"><span title="Chat Server Host">Chat Server Host</span></th>
		<td class="alt1">
			<input type="text" id="fc_server_host" name="fc_server_host" size="50" value="<?php echo $fcsetting['fc_server_host'];?>"> Default: <?php echo $_SERVER['SERVER_NAME'];?>
		</td>
	</tr>
	<tr valign="top" id="chat_port" <?php if(!$valid || $fcsetting['fc_extendserver'] != 0){ ?>style="display:none;"<?php } ?> >
		<th class="alt2"><span title="Chat Server Port">Chat Server Port</span></th>
		<td class="alt2">
			<input type="text" id="fc_server_port" name="fc_server_port" size="10" value="<?php echo $fcsetting['fc_server_port'];?>"> Default: <span id="default_server_port"><?php if($fcsetting['fc_servertype'] == 0){?>51127<?php }else{ ?>51212<?php } ?></span>
		</td>
	</tr>
	<tr valign="top" id="http_port" <?php if(!$valid || $fcsetting['fc_extendserver'] != 0){ ?>style="display:none;"<?php } ?> >
		<th class="alt1"><span title="Chat Http Port">Chat Http Port</span></th>
		<td class="alt1">
			<input type="text" id="fc_server_port_h" name="fc_server_port_h" size="10" value="<?php echo $fcsetting['fc_server_port_h'];?>"> Default: <span id="default_http_port"><?php if($fcsetting['fc_servertype'] == 0){?>35555<?php }else{ ?>31212<?php } ?></span>
		</td>
	</tr>
	<tr valign="top" id="client_location" <?php if($fcsetting['fc_extendserver'] == 2){ ?>style="display:none;"<?php } ?> >
		<th class="alt1"><span title="e.g. http://host123.123flashchat.com/group_name/">Chat Client Location</span></th>
		<td class="alt1">
			<input type="text" id="fc_client_loc" name="fc_client_loc" size="50" value="<?php echo $fcsetting['fc_client_loc'];?>">
			<span id="client_loc0" <?php if($fcsetting['fc_extendserver'] != 0){?>style="display:none;"<?php } ?>>Example: http:/<?php echo $_SERVER['SERVER_NAME']; ?>:<?php if($fcsetting['fc_servertype'] == 0){?>35555<?php }else{ ?>31212<?php } ?>/</span>
            <span id="client_loc1" <?php if($fcsetting['fc_extendserver'] != 1){?>style="display:none;"<?php } ?>>Example: http://hostxxx.123flashchat.com/group_name/</span> 
		</td>
	</tr>
	<tr valign="top" id="room_name" <?php if($fcsetting['fc_extendserver'] != 2){ ?>style="display:none;"<?php } ?> >
		<th class="alt1"><span title="If you leave it blank, the room name will be Lobby as default">Chat Room</span></th>
        <td class="alt1">
			<input type="text" name="fc_room" value="<?php echo $fcsetting['fc_room'];?>">
		</td>
	</tr>
	<tr valign="top" id="client_type" <?php if($fcsetting['fc_extendserver'] == 2 || ($fcsetting['fc_extendserver'] == 0 && $fcsetting['fc_servertype'] ==1)){ ?>style="display:none;"<?php } ?> >
		<th class="alt2"><span>Client Type</span></th>
		<td class="alt2">
			<input type="radio" name="fc_clienttype" id="fc_clienttype0" value="0" <?php if($fcsetting['fc_clienttype'] == 0){ ?>checked="checked"<?php } ?> /> <label for="fc_clienttype0">Html Chat</label>
			<input type="radio" name="fc_clienttype" id="fc_clienttype1" value="1" <?php if($fcsetting['fc_clienttype'] == 1){ ?>checked="checked"<?php } ?> /> <label for="fc_clienttype1">Flash Chat</label>
		</td>
	</tr>
	<tr valign="top">
		<th class="alt2"><span title="Whether you want show online user list in chat status mod?">Show User List</span></th>
		<td class="alt2">
			<input type="radio" name="fc_user_list" id="fc_user_list1" value="1" <?php if($fcsetting['fc_user_list'] == 1){ ?>checked="checked"<?php } ?> /> <label for="fc_user_list1">Yes</label>
			<input type="radio" name="fc_user_list" id="fc_user_list0" value="0" <?php if($fcsetting['fc_user_list'] == 0){ ?>checked="checked"<?php } ?> /> <label for="fc_user_list0">No</label>
		</td>
	</tr>
	<tr valign="top" id="room_list" <?php if($fcsetting['fc_extendserver'] == 2){ ?>style="display:none;"<?php } ?> >
		<th class="alt1"><span title="Whether you want show chat room list in chat status mod?">Show Room List</span></th>
		<td class="alt1">
			<input type="radio" name="fc_room_list" id="fc_room_list1" value="1" <?php if($fcsetting['fc_room_list'] == 1){ ?>checked="checked"<?php } ?> /> <label for="fc_room_list1">Yes</label>
			<input type="radio" name="fc_room_list" id="fc_room_list0" value="0" <?php if($fcsetting['fc_room_list'] == 0){ ?>checked="checked"<?php } ?> /> <label for="fc_room_list0">No</label>
		</td>
	</tr>
	<tr valign="top">
		<th class="alt1"><span>Chat Client Size:</span></th>
		<td class="alt1">
			<input type="radio" onclick="showchatsize(0);" name="fc_fullscreen" id="fc_fullscreen1" value="1" <?php if($fcsetting['fc_fullscreen'] == 1){ ?>checked="checked"<?php } ?> />
			<label for="fc_fullscreen1">Full Screen</label>
			<input type="radio" onclick="showchatsize(1);" name="fc_fullscreen" id="fc_fullscreen0" value="0" <?php if($fcsetting['fc_fullscreen'] == 0){ ?>checked="checked"<?php } ?> />
			<label for="fc_fullscreen0">Custom</label> 
			<span id="chatsize" <?php if($fcsetting['fc_fullscreen'] == 1){ ?>style="display:none;"<?php } ?>> 
				Width:<input type="text" name="fc_client_width" value="<?php echo $fcsetting['fc_client_width'];?>" />  
				Height:<input type="text" name="fc_client_height" value="<?php echo $fcsetting['fc_client_height'];?>" />
			</span>
		</td>
	</tr>
	<tr valign="top">
		<th class="alt2"><span title="Chat Client Language">Chat Client Language</span></th>
		<td class="alt2">
			<div id="u_al" <?php if($fcsetting['fc_extendserver'] == 2){ ?>style="display:none;"<?php } ?> > Note: You can set the language in 123FlashChat Admin Panel -&gt; Client Settings -&gt; Languages </div>
			<select name="fc_client_lang" id="set_lang" <?php if($fcsetting['fc_extendserver'] != 2){ ?>style="display:none;"<?php } ?>>
				<option value="auto" >Auto detect</option>
				<option value="en" <?php if($fcsetting['fc_client_lang'] == "en"){?>selected="selected"<?php } ?>>English</option>
				<option value="zh-CN" <?php if($fcsetting['fc_client_lang'] == "zh-CN"){?>selected="selected"<?php } ?>>GB Chinese</option>
				<option value="zh-TW" <?php if($fcsetting['fc_client_lang'] == "zh-TW"){?>selected="selected"<?php } ?>>Big5 Chinese</option>
				<option value="fr" <?php if($fcsetting['fc_client_lang'] == "fr"){?>selected="selected"<?php } ?>>French</option>
				<option value="it" <?php if($fcsetting['fc_client_lang'] == "it"){?>selected="selected"<?php } ?>>Italian</option>
				<option value="de" <?php if($fcsetting['fc_client_lang'] == "de"){?>selected="selected"<?php } ?>>German</option>
				<option value="nl" <?php if($fcsetting['fc_client_lang'] == "nl"){?>selected="selected"<?php } ?>>Dutch</option>
				<option value="hu" <?php if($fcsetting['fc_client_lang'] == "hu"){?>selected="selected"<?php } ?>>Hungarian</option>
				<option value="es" <?php if($fcsetting['fc_client_lang'] == "es"){?>selected="selected"<?php } ?>>Spanish</option>
				<option value="hr" <?php if($fcsetting['fc_client_lang'] == "hr"){?>selected="selected"<?php } ?>>Croatian</option>
				<option value="tr" <?php if($fcsetting['fc_client_lang'] == "tr"){?>selected="selected"<?php } ?>>Turkish</option>
				<option value="ar" <?php if($fcsetting['fc_client_lang'] == "ar"){?>selected="selected"<?php } ?>>Arabic</option>
				<option value="pt" <?php if($fcsetting['fc_client_lang'] == "pt"){?>selected="selected"<?php } ?>>Portuguese</option>
				<option value="ru" <?php if($fcsetting['fc_client_lang'] == "ru"){?>selected="selected"<?php } ?>>Russian</option>
				<option value="ko" <?php if($fcsetting['fc_client_lang'] == "ko"){?>selected="selected"<?php } ?>>Korean</option>
				<option value="serbian" <?php if($fcsetting['fc_client_lang'] == "serbian"){?>selected="selected"<?php } ?>>Serbian</option>
				<option value="no" <?php if($fcsetting['fc_client_lang'] == "no"){?>selected="selected"<?php } ?>>Norwegian</option>
				<option value="ja" <?php if($fcsetting['fc_client_lang'] == "ja"){?>selected="selected"<?php } ?>>Japanese</option>
			</select>
		</td>
	</tr>
	<tr valign="top">
		<th class="alt1"><span title="Chat Client Skin">Chat Client Skin</span></th>
		<td class="alt1">
			<div id="u_as" <?php if($fcsetting['fc_extendserver'] == 2){ ?>style="display:none;"<?php } ?> > Note: You can set the skin in 123FlashChat Admin Panel -&gt; Client Settings -&gt; Skin</div>
			<select name="fc_client_skin" id="set_skin" <?php if($fcsetting['fc_extendserver'] != 2){ ?>style="display:none;"<?php } ?>>
				<option value="default" <?php if($fcsetting['fc_client_skin'] == "default"){?>selected="selected"<?php } ?>>Default</option>
				<option value="green" <?php if($fcsetting['fc_client_skin'] == "green"){?>selected="selected"<?php } ?>>Green</option>
				<option value="orange" <?php if($fcsetting['fc_client_skin'] == "orange"){?>selected="selected"<?php } ?>>Orange</option>
				<option value="red" <?php if($fcsetting['fc_client_skin'] == "red"){?>selected="selected"<?php } ?>>Red</option>
				<option value="black" <?php if($fcsetting['fc_client_skin'] == "black"){?>selected="selected"<?php } ?>>Black</option>
				<option value="beige" <?php if($fcsetting['fc_client_skin'] == "beige"){?>selected="selected"<?php } ?>>Beige</option>
				<option value="standard" <?php if($fcsetting['fc_client_skin'] == "standard"){?>selected="selected"<?php } ?>>Standard</option>
				<option value="clean" <?php if($fcsetting['fc_client_skin'] == "clean"){?>selected="selected"<?php } ?>>Clean</option>
				<option value="artistic" <?php if($fcsetting['fc_client_skin'] == "artistic"){?>selected="selected"<?php } ?>>Artistic</option>
				<option value="lightblue" <?php if($fcsetting['fc_client_skin'] == "lightblue"){?>selected="selected"<?php } ?>>Light Blue</option>
			</select>
		</td>
	</tr>
	<tr>
		<td class="tfoot" colspan="2" align="center">	
			<input type="hidden" name="server_loc" id="server_loc" value="<?php echo $valid; ?>" />
			<input type="submit" id="submit0" class="button" tabindex="1" value="  Save  " accesskey="s" />
		</td>
	</tr>
<?php	
    print_table_footer();
?>
</div>
<?php
}

if ($_REQUEST['do'] == "adminpanel"){
?>
<div class="pagetitle">123 Flash Chat Admin Panel</div>
<div class="acp-content-wrapper">
<?php
    if ($vbulletin->options['fc_extendserver'] == 2){	
		//print_table_header($vbphrase['chat_admin_panel'], 2, 0); 
?>
		<table cellpadding="4" cellspacing="0" border="0" width="100%" style="border-collapse:separate;margin:0 auto;" class="tborder" id="cpform_table">
			<?php print_table_header($vbphrase['chat_admin_panel'], 2, 0); ?>		
			<tr>
				<td style="text-align:center;">
					<p>Sorry! Admin Panel is not available in the Free Chat Hosting Edition. 123FlashChat Full Version starts at $20.</p>
					<p>Click the link below to have a live Admin Panel Demo for testing.</p>
					<p><a href="http://www.123flashchat.com/admin-panel-free.html" target="_blank"><strong>Live Demo</strong></a></p>
				</td>
			</tr>
			<?php print_table_footer(); ?>
		</table>
<?php
    }else{
    	$admin_url = $vbulletin->options['fc_client_loc'] . 'admin_123flashchat.swf?init_host='.$vbulletin->options['fc_server_host'].'&init_port='.$vbulletin->options['fc_server_port'];
    	$admin_url .= ($vbulletin->options['fc_server_host_s'] ? '&init_host_s='.$vbulletin->options['fc_server_host_s'] : '') . ($vbulletin->options['fc_server_port_s'] ? '&init_port_s='.$vbulletin->options['fc_server_port_s'] : '');
    	$admin_url .= ($vbulletin->options['fc_server_host_h'] ? '&init_host_h='.$vbulletin->options['fc_server_host_h'] : '') . ($vbulletin->options['fc_server_port_h'] ? '&init_port_h='.$vbulletin->options['fc_server_port_h'] : '');
    	$admin_url .=  ($vbulletin->options['fc_extendserver'] == 1) ? "&init_group=" . $vbulletin->options['fc_group'] : "";
		if(!empty($vbulletin->userinfo['username']) && !empty($vbulletin->userinfo['password']) ){
			$admin_url .= "&init_user=".$vbulletin->userinfo['username']."&init_password=".$vbulletin->userinfo['password'];
		}
?>
		<table cellpadding="4" cellspacing="0" border="0" width="100%" style="border-collapse:separate;margin:0 auto;" class="tborder" id="cpform_table">
			<?php print_table_header($vbphrase['chat_admin_panel'], 2, 0); ?>
			<tr>
				<td style="text-align:center;">
					<script src="<?php echo $vbulletin->options['fc_client_loc']; ?>123flashchat.js"></script>
					<object  width="100%" height="600" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,19,0" id="topcmm_123flashchat" type="application/x-shockwave-flash">
						<param name=movie value="<?php echo $admin_url; ?>">
						<param name=quality value="high">
						<param name="menu" value="false">
						<param name="allowScriptAccess" value="always">
						<embed width="100%" height="600" src="<?php echo $admin_url; ?>" quality="high" menu="false"  type="application/x-shockwave-flash" allowScriptAccess="always"  pluginspace="http://www.macromedia.com/go/getflashplayer"  name="topcmm_123flashchat"></embed>
					</object>
				</td>
			</tr>
			<?php print_table_footer(); ?>
		</table>
<?php
    }
?>
</div>
<?php
}

print_cp_footer();
?>